package MyBB;
use 5.014;
use Bread::Board;

sub setup {
    my ($class) = @_;

    return container 'CouchPotatoe' => as {
        service 'FindNewSeries' => (
            class        => 'FindNewSeries',
            dependencies => {
                ua        => '/Component/LWP-UserAgent',
                formatter => '/Component/Number-Format',
                renderer  => '/Component/TT',
            }
        );
        container 'Component' => as {
            service 'LWP-UserAgent' => (
                class     => 'LWP::UserAgent',
                lifecycle => 'Singleton',
            );
            service 'Number-Format' => (
                class     => 'Number::Format',
                lifecycle => 'Singleton',
            );
            service 'TT' => (
                class     => 'Template',
                lifecycle => 'Singleton',
                block     => sub {
                    return Template->new(
                        INCLUDE_PATH => $FindBin::Bin . '/../tt/' );
                },
            );
        };
    };
}

1;
