package FindNewSeries;
use 5.014;
use Moose;
use namespace::autoclean;

use LWP::UserAgent;
use XML::Feed;
use Number::Format;
use Template;

my $ua = LWP::UserAgent->new(
    agent   => 'domms new series finder',
    timeout => 5,
);

my $formatter = Number::Format->new;

my $tt = Template->new( INCLUDE_PATH => $FindBin::Bin . '/../tt/', );

sub run {
    my ($self) = @_;
    my $html   = $self->fetch;
    my $data   = $self->find($html);
    $self->write($data);
}

sub fetch {
    my ($self) = @_;

    my $res = $ua->get('http://www.ezrss.it/feed');
    if ( $res->is_success ) {
        return $res->decoded_content;
    }
    else {
        die $res->status_line;
    }
}

sub find {
    my ( $self, $html ) = @_;
    my @data;
    my $feed = XML::Feed->parse( \$html );
    foreach my $item ( $feed->entries ) {
        next unless $item->title =~ /\s1x1\s/ || $item->title =~ /s01e01/i;
        next if $item->enclosure->length > 800_000_000;
        next if $item->title =~ /720p/i;
        push(
            @data,
            {
                title => $item->title,
                size  => $formatter->format_bytes( $item->enclosure->length ),
                url   => $item->enclosure->url,
            }
        );
    }
    return \@data if @data;
}

sub write {
    my ( $self, $data ) = @_;

    my $out;
    $tt->process( 'new_series.tt', { data => $data }, \$out )
      || die $tt->error();
    return $out;
}

__PACKAGE__->meta->make_immutable;
1;
