package FindNewSeries;
use 5.014;
use Moose;
use namespace::autoclean;

use XML::Feed;

sub run {
    my ($self, $ua, $formatter, $tt) = @_;
    my $html   = $self->fetch($ua);
    my $data   = $self->find($formatter, $html);
    $self->write($tt, $data);
}

sub fetch {
    my ($self, $ua) = @_;

    my $res = $ua->get('http://www.ezrss.it/feed');
    if ( $res->is_success ) {
        return $res->decoded_content;
    }
    else {
        die $res->status_line;
    }
}

sub find {
    my ( $self, $formatter, $html ) = @_;
    my @data;
    my $feed = XML::Feed->parse( \$html );
    foreach my $item ( $feed->entries ) {
        next unless $item->title =~ /\s1x1\s/ || $item->title =~ /s01e01/i;
        next if $item->enclosure->length > 800_000_000;
        next if $item->title =~ /720p/i;
        push(
            @data,
            {
                title => $item->title,
                size  => $formatter->format_bytes( $item->enclosure->length ),
                url   => $item->enclosure->url,
            }
        );
    }
    return \@data if @data;
}

sub write {
    my ( $self, $tt, $data ) = @_;

    my $out;
    $tt->process( 'new_series.tt', { data => $data }, \$out )
      || die $tt->error();
    return $out;
}

__PACKAGE__->meta->make_immutable;
1;
