package MyBB;
use 5.014;
use Bread::Board;

sub setup {
    my ( $class, $env_name ) = @_;

    my $env = $class->$env_name;

    my $apps = container 'CouchPotatoe' => ['Env'] => as {
        service 'FindNewSeries' => (
            class        => 'FindNewSeries',
            dependencies => {
                ua        => '/Env/UserAgent',
                formatter => '/Component/Number-Format',
                renderer  => '/Env/Renderer',
            }
        );
        container 'Component' => as {
            service 'LWP-UserAgent' => (
                class     => 'LWP::UserAgent',
                lifecycle => 'Singleton',
            );
            service 'Number-Format' => (
                class     => 'Number::Format',
                lifecycle => 'Singleton',
            );
            service 'TT' => (
                class     => 'Template',
                lifecycle => 'Singleton',
                block     => sub {
                    return Template->new(
                        INCLUDE_PATH => $FindBin::Bin . '/../tt/' );
                },
            );
            service 'MockUA' => (
                class     => 'MockUA',
                lifecycle => 'Singleton',
            );
            service 'MockTT' => (
                class     => 'MockTT',
                lifecycle => 'Singleton',
            );
        };
    };

    return $apps->create( 'Env' => $env );
}

sub dev {
    my ($class) = @_;
    return container 'Dev' => as {
        alias 'UserAgent' => '/Component/MockUA';
        alias 'Renderer'  => '/Component/MockTT';
    };
}

sub prod {
    my ($class) = @_;
    return container 'Prod' => as {
        alias 'UserAgent' => '/Component/LWP-UserAgent';
        alias 'Renderer'  => '/Component/TT';
    };
}

1;
